scala.xml.persistent

# CachedFileStorage

#### abstract class CachedFileStorage extends Thread with Logged

Mutable storage of immutable xml trees. Everything is kept in memory, with a thread periodically checking for changes and writing to file.

To ensure atomicity, two files are used, `filename1` and `'$'+filename1`. The implementation switches between the two, deleting the older one after a complete dump of the database has been written.

Source
  CachedFileStorage.scala

Linear Supertypes
Logged, Thread, Runnable, AnyRef, Any
Known Subclasses
SetStorage
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. CachedFileStorage
2. Logged
3. Thread
4. Runnable
5. AnyRef
6. Any

Implicitly

1. by any2stringadd
2. by any2stringfmt
3. by any2ArrowAssoc
4. by any2Ensuring

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new CachedFileStorage(file1: File)

### Abstract Value Members

1. #### abstract def +=(e: Node): Unit

   adds a node, setting this.

   adds a node, setting this.dirty to true as a side effect

2. #### abstract def -=(e: Node): Unit

   removes a tree, setting this.

   removes a tree, setting this.dirty to true as a side effect

3. #### abstract def nodes: collection.Iterator[Node]

   returns an iterator over the nodes in this storage

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from CachedFileStorage to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ->[B](y: B): (CachedFileStorage, B)

   Implicit information
     This member is added by an implicit conversion from CachedFileStorage to ArrowAssoc[CachedFileStorage] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

6. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

9. #### final def checkAccess(): Unit

   Definition Classes
     Thread

10. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      Thread → AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

11. #### var dirty: Boolean

    this storage modified since last modification check

    this storage modified since last modification check

    Attributes
      protected

12. #### def ensuring(cond: (CachedFileStorage) ⇒ Boolean, msg: ⇒ Any): CachedFileStorage

    Implicit information
      This member is added by an implicit conversion from CachedFileStorage to Ensuring[CachedFileStorage] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: (CachedFileStorage) ⇒ Boolean): CachedFileStorage

    Implicit information
      This member is added by an implicit conversion from CachedFileStorage to Ensuring[CachedFileStorage] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: Boolean, msg: ⇒ Any): CachedFileStorage

    Implicit information
      This member is added by an implicit conversion from CachedFileStorage to Ensuring[CachedFileStorage] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: Boolean): CachedFileStorage

    Implicit information
      This member is added by an implicit conversion from CachedFileStorage to Ensuring[CachedFileStorage] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

17. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

18. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

19. #### def flush(): Unit

    Force writing of contents to the file, even if there has not been any update.

20. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from CachedFileStorage to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

21. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

22. #### def getContextClassLoader(): ClassLoader

    Definition Classes
      Thread

23. #### def getId(): Long

    Definition Classes
      Thread

24. #### final def getName(): String

    Definition Classes
      Thread

25. #### final def getPriority(): Int

    Definition Classes
      Thread

26. #### def getStackTrace(): Array[StackTraceElement]

    Definition Classes
      Thread

27. #### def getState(): State

    Definition Classes
      Thread

28. #### final def getThreadGroup(): ThreadGroup

    Definition Classes
      Thread

29. #### def getUncaughtExceptionHandler(): UncaughtExceptionHandler

    Definition Classes
      Thread

30. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

31. #### def initialNodes: collection.Iterator[Node]

    finds and loads the storage file.

    finds and loads the storage file. subclasses should call this method prior to any other, but only once, to obtain the initial sequence of nodes.

    Attributes
      protected

32. #### def interrupt(): Unit

    Definition Classes
      Thread

33. #### val interval: Int

    period between modification checks, in milliseconds

    period between modification checks, in milliseconds

    Attributes
      protected

34. #### final def isAlive(): Boolean

    Definition Classes
      Thread

35. #### final def isDaemon(): Boolean

    Definition Classes
      Thread

36. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

37. #### def isInterrupted(): Boolean

    Definition Classes
      Thread

38. #### final def join(): Unit

    Definition Classes
      Thread
    Annotations
      @throws()

39. #### final def join(arg0: Long, arg1: Int): Unit

    Definition Classes
      Thread
    Annotations
      @throws()

40. #### final def join(arg0: Long): Unit

    Definition Classes
      Thread
    Annotations
      @throws()

41. #### def log(msg: String): Unit

    This method should log the message given as argument somewhere as a side-effect.

    This method should log the message given as argument somewhere as a side-effect.

    msg

      message to be logged

    Definition Classes
      Logged

42. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

43. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

44. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

45. #### def run(): Unit

    Run method of the thread.

    Run method of the thread. remember to use `start()` to start a thread, not `run`.

    Definition Classes
      CachedFileStorage → Thread → Runnable

46. #### def setContextClassLoader(arg0: ClassLoader): Unit

    Definition Classes
      Thread

47. #### final def setDaemon(arg0: Boolean): Unit

    Definition Classes
      Thread

48. #### final def setName(arg0: String): Unit

    Definition Classes
      Thread

49. #### final def setPriority(arg0: Int): Unit

    Definition Classes
      Thread

50. #### def setUncaughtExceptionHandler(arg0: UncaughtExceptionHandler): Unit

    Definition Classes
      Thread

51. #### def start(): Unit

    Definition Classes
      Thread

52. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

53. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      Thread → AnyRef → Any

54. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

55. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

56. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

57. #### def →[B](y: B): (CachedFileStorage, B)

    Implicit information
      This member is added by an implicit conversion from CachedFileStorage to ArrowAssoc[CachedFileStorage] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implict Value Members

1. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from CachedFileStorage to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (cachedFileStorage: StringAdd).self

   Definition Classes
     StringAdd

2. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from CachedFileStorage to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (cachedFileStorage: StringFormat).self

   Definition Classes
     StringFormat

### Deprecated Value Members

1. #### def countStackFrames(): Int

   Definition Classes
     Thread
   Annotations
     @Deprecated @deprecated
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

2. #### def destroy(): Unit

   Definition Classes
     Thread
   Annotations
     @Deprecated @deprecated
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

3. #### final def resume(): Unit

   Definition Classes
     Thread
   Annotations
     @Deprecated @deprecated
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

4. #### final def stop(arg0: java.lang.Throwable): Unit

   Definition Classes
     Thread
   Annotations
     @Deprecated @deprecated
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

5. #### final def stop(): Unit

   Definition Classes
     Thread
   Annotations
     @Deprecated @deprecated
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

6. #### final def suspend(): Unit

   Definition Classes
     Thread
   Annotations
     @Deprecated @deprecated
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

7. #### def x: CachedFileStorage

   Implicit information
     This member is added by an implicit conversion from CachedFileStorage to ArrowAssoc[CachedFileStorage] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (cachedFileStorage: ArrowAssoc[CachedFileStorage]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

8. #### def x: CachedFileStorage

   Implicit information
     This member is added by an implicit conversion from CachedFileStorage to Ensuring[CachedFileStorage] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (cachedFileStorage: Ensuring[CachedFileStorage]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from Logged

### Inherited from Thread

### Inherited from Runnable

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from CachedFileStorage to StringAdd

### Inherited by implicit conversion any2stringfmt from CachedFileStorage to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from CachedFileStorage to ArrowAssoc[CachedFileStorage]

### Inherited by implicit conversion any2Ensuring from CachedFileStorage to Ensuring[CachedFileStorage]

### Ungrouped